	integer*4 iter,idem,iouter
	real*4 total,time
	DO 10 idem = 100,1000,100
		iter = 1.5e08/(2.0*idem*idem)
		write(*,*) "idem =",idem,"   iter = ",iter," iouter =",iouter
		call whetdots (iter,idem,iouter,total,time,whets)
		write(*,*)"   double mflops = ",whets," ops =",total," sec=",time
10		CONTINUE
	DO 20 idem = 1200,2000,200
		iter = 1.5e08/(2.0*idem*idem)
		write(*,*) "idem =",idem,"   iter = ",iter," iouter =",iouter
		call whetdots (iter,idem,iouter,total,time,whets)
		write(*,*)"   double mflops = ",whets," ops =",total," sec=",time
20		CONTINUE
	DO 30 idem = 2500,8000,500
		iter = 1.5e08/(2.0*idem*idem)
		write(*,*) "idem =",idem,"   iter = ",iter," iouter =",iouter
		call whetdots (iter,idem,iouter,total,time,whets)
		write(*,*)"   double mflops = ",whets," ops =",total," sec=",time
30		CONTINUE
	DO 40 idem = 10000,128000,10000
		iter = 1.5e08/(2.0*idem*idem)
		write(*,*) "idem =",idem,"   iter = ",iter," iouter =",iouter
		call whetdots (iter,idem,iouter,total,time,whets)
		write(*,*)"   double mflops = ",whets," ops =",total," sec=",time
40		CONTINUE
	end

c---------------------------------------------------------------------------|
c                                                                           |
c Purpose: measures Fortran and CPU performance doing singe precision       |
c          dot product                                                      |
c                                                                           |
c---------------------------------------------------------------------------|

      subroutine whetdots (iter,idem,iouter,total,time,whets)
      parameter (isize=128000)
      real*4 total,once,time

      integer*4 iTEMP,itest,i,j,jj,SEC_100,idem,iouter,iout

      REAL*8 A(isize),B(isize),C(isize)
c
c    Initialize the arrays before the clock goes off
c
          DO 5 J = 1,idem
              A(J) = 50*J 
              B(J) = 77/J + 11/J
              C(J) = 0.0
5     CONTINUE

      iouter = idem	! set up loops to handle large arrays
      if (iter.lt.1) THEN
      	iter = 1
	iouter = 1.5e08/(2.0*idem)
	endif
	iout = iouter		! make iout a local variable
      iTEMP = SEC_100()
      time0 = (iTEMP)/100.0
c
c    ***** BEGININNING OF TIMED INTERVAL *****
c
      DO 200 jj = 1,iter
c
          DO 150 I = 1,iout
                  C(I) = 0.0			! idem size loops
                  DO 130 K = 1,idem		! 2*idem operations
                      C(I) = C(I) + A(K)*B(K)
  130             CONTINUE
  150     CONTINUE

  200 continue
c
c    ***** END OF TIMED INTERVAL *****
c
      iTEMP = SEC_100()
      TIME1 = (iTEMP)/100.0
      WHETS = (dble(2*idem*iouter) * dble(iter))/(TIME1-TIME0)
      time = time1 -time0
      total = (dble(2*idem*iouter)*dble(iter))
      whets = total/time

      return
      END
